# frozen_string_literal: true

require 'colorize'

# Takes a Merge Request and, if confidential issues are referenced, posts a
# message to a given Slack channel.
#
# Use https://app.slack.com/block-kit-builder/ to easily experiment with
# improved messaging format.
module Alerter
  class Slack
    TOKEN_ENV_VAR_NAME = 'SLACK_BOT_OAUTH_TOKEN'

    MESSAGE_FOOTERS = [
      {
        type: 'section',
        text: {
          type: 'mrkdwn',
          text: "React with a :white_check_mark: when you've addressed this alert."
        }
      },
      {
        type: 'context',
        elements: [
          {
            type: 'mrkdwn',
            text: 'Generated by <https://gitlab.com/gitlab-com/gl-security/product-security/appsec/tooling/public-mr-confidential-issue-detector/|MR CID>.'
          }
        ]
      },
      {
        type: 'divider'
      }
    ].freeze

    def self.alert(merge_request, channel, force: false)
      with_caching(merge_request, channel, force) do
        retries ||= 0
        if (message = slack_message_for_mr(merge_request))
          slack.chat_postMessage(
            channel:,
            blocks: message[:blocks],
            unfurl_links: false
          )
        end
      rescue StandardError => e
        puts e
        raise e unless (retries += 1) <= 3

        puts "Retrying after error; Sleeping #{retries * 2} first..."
        sleep retries * 2
        retry
      end
    end

    def self.with_caching(merge_request, _channel, force)
      key = merge_request.attributes.references.full
      if (alerted_at = Cache::AlertHistory.cache.alerted_at(key, 'slack'))
        if force
          puts 'Forcing another alert to Slack...'
        else
          puts "Already alerted on Slack: #{alerted_at}"
          return
        end
      end

      yield

      Cache::AlertHistory.cache.add_alert(key, 'slack', Time.now.utc)
      Cache::AlertHistory.cache.flush
    end

    def self.slack_message_for_mr(merge_request)
      issues = merge_request.find_referenced_confidential_issues
      message = { blocks: [] }

      message_text = ''

      severity = merge_request.severity_from_labels
      message_text += ":s#{severity}: " if severity

      message_text += "<#{merge_request.attributes.web_url}|*#{CGI.escapeHTML(merge_request.attributes.title)}* (#{merge_request.attributes.references.full})> " \
                      "was opened by `#{merge_request.attributes.author.username}` " \
                      "on `#{merge_request.attributes.created_at}`. "

      message_text += "The MR has the label `severity::#{severity}`. " if severity

      if merge_request.alertable_labels.any?
        message_text += "\n\n:warning: " \
                        "It has `#{merge_request.alertable_labels}` labels!" \
                        "\n\n"
      end

      message_text += if issues.any?
                        'It references the following confidential issue(s):'
                      else
                        'It references no confidential issues.'
                      end

      # Offending MR
      message[:blocks] << {
        type: 'section',
        text: {
          type: 'mrkdwn',
          text: message_text
        }
      }

      # Confidential issues (if any)
      message[:blocks] << slack_message_for_issues(issues) if issues.any?

      # Footer
      message[:blocks] += MESSAGE_FOOTERS

      message
    end

    # We can't mix markdown and lists, so we approximate with the bullet symbol
    def self.slack_message_for_issues(issues)
      list = issues.each.collect do |issue|
        message = "<#{issue.attributes.web_url}|*#{CGI.escapeHTML(issue.attributes.title)}* (#{issue.attributes.references.full})>"

        # Wrap with a warning if the issue has a vuln tag
        message = ":warning: #{message} (`~bug::vulnerability` tag present)" if issue.vulnerability?

        "• #{message}"
      end.uniq.join("\n")

      {
        type: 'section',
        text: {
          type: 'mrkdwn',
          text: list
        }
      }
    end

    def self.slack
      @slack ||= ::Slack::Web::Client.new
    end
  end
end
